#include <Arduino.h>
xQueueHandle queue_handle = NULL;

void tx(void *p){
  int putvalue = 0;
  while (true)
  {
    //Serial.print("tx() send to queue: ");
    // 1 experiment we not wait to insert Queue and pls comment out rx() left only while loop do nothing 
    //if (xQueueSend(queue_handle, &putvalue, 0) != NULL)
    // 2 experiment we wait a bit longer, result will show the FAIL msg will slowly update
    //   notice that the OK 2 msg insert same speed as in 1st experiment since the queue is not full
    
    
    //if (xQueueSend(queue_handle, &putvalue, 3000) != NULL)
    //{
    //  Serial.println("OK");
    //}else{
    //  Serial.println("FAIL!!");
    //}
    
    vTaskDelay(200 / portTICK_PERIOD_MS);
    
  }
}

void rx(void *p){
   int getvalue = 0;
   while(true){
     // 1 experiment comment every thing in side this while loop to make tx() fill the queue and see adjust timeout on
     //   tx() queue to wait longer or shorter and observe the delay of FAIL msg print out.
     // 3 experiment, if we retrive from queue as same TIMEOUT as put in queue
     //   We should not see fail. Moreover, it will do task in this rx queue 
     //   before return to tx queue. it will print rx 1, rx 2 before print "OK" in tx queue
     if (xQueueReceive(queue_handle, &getvalue, 3000)){
        Serial.println("rx() got item from queue");
          Serial.println("\t\t\t\t rx 1");
          Serial.println("\t\t\t\t rx 2");
     // 4 if rx cannot get any item from queue and wait for 3000 sec
     //   To test, just comment out everything left only vTaskDelay in while loop of sending queue
     //   
     }else{
        Serial.println("rx() failed to get items from queue within 3000 tick");
     }
     
   }

}

void setup()
{
  Serial.begin(115200);
  vTaskDelay(5000 / portTICK_PERIOD_MS);
  Serial.println("\r\n -------- FreeRTOS ESP32_Queue_TxRx ----------");
  queue_handle = xQueueCreate(2, sizeof(int));
  xTaskCreate(tx, "txQueueTask", 1024, NULL, tskIDLE_PRIORITY - 1, NULL);
  xTaskCreate(rx, "rxQueueTask", 1024, NULL, tskIDLE_PRIORITY - 1, NULL);
}

void loop() {}